From 0293edce118d5edb6927e7d26fbda875d426160d Mon Sep 17 00:00:00 2001
From: MohammadHossein Qanbari <mohammad.qanbari@qt.io>
Date: Mon, 22 Jan 2024 14:02:02 +0100
Subject: [PATCH] Lightning Viewer Example: Use QML Module and Restructure
 Project Files

The QML files are being used as QML module. Also all resource files are
moved to src/ sub-directory. The icons which used in qml resources are
moved to resources/qml/icons/ from resources/assets/icons/.

Task-number: QTBUG-121123
Pick-to: 6.7
Change-Id: I28381ccf65da52c6c7288a23a9540232c1a18d71
---
 .../{resources/qml => }/ActionsLayer.qml      |   3 +-
 examples/demos/lightningviewer/CMakeLists.txt |  97 +++++++++----
 .../{resources/qml => }/DistanceTimeLayer.qml |   1 +
 .../{resources/qml => }/LightningMapLayer.qml |   1 +
 .../{resources/qml => }/LightningView.qml     |  10 +-
 .../qml => }/LightningViewConfig.qml          |   0
 examples/demos/lightningviewer/Main.qml       |  22 +++
 .../{resources/qml => }/MapLayersDrawer.qml   |   2 +-
 .../{resources/qml => }/MapLayersItem.qml     |   3 +-
 .../{resources/qml => }/MapType.qml           |   0
 .../{resources/qml => }/MapView.qml           |   0
 .../{resources/qml => }/SwitchMap.qml         |   3 +-
 examples/demos/lightningviewer/controller.cpp |   8 +-
 examples/demos/lightningviewer/controller.h   |   9 +-
 .../{resources/assets => }/icons/distance.svg |   0
 .../{resources/assets => }/icons/globe.svg    |   0
 .../assets => }/icons/lightning-layer.svg     |   0
 .../assets => }/icons/lightning-strike.svg    |   0
 .../assets => }/icons/map-layers.svg          |   0
 .../{resources/assets => }/icons/map.svg      |   0
 .../{resources/assets => }/icons/recenter.svg |   0
 .../assets => }/icons/user-location.svg       |   0
 .../{data => }/laststrikeinfo.h               |   0
 .../{data => }/lightningitemdata.cpp          |   0
 .../{data => }/lightningitemdata.h            |   1 +
 .../{models => }/lightningitemmodel.cpp       |   2 +-
 .../{models => }/lightningitemmodel.h         |   2 +-
 .../{providers => }/lightningprovider.cpp     |   0
 .../{providers => }/lightningprovider.h       |   2 +-
 .../{resources => }/lv_style/Button.qml       |   0
 .../lightningviewer/lv_style/CMakeLists.txt   | 135 ++++++++++++++++++
 .../{resources => }/lv_style/Config.qml       |   0
 .../{resources => }/lv_style/RoundButton.qml  |   0
 .../{resources => }/lv_style/StyleImage.qml   |   0
 .../button-background-checked-disabled.png    | Bin
 .../button-background-checked-disabled@2x.png | Bin
 .../button-background-checked-hovered.png     | Bin
 .../button-background-checked-hovered@2x.png  | Bin
 .../button-background-checked-pressed.png     | Bin
 .../button-background-checked-pressed@2x.png  | Bin
 .../dark/images/button-background-checked.png | Bin
 .../images/button-background-checked@2x.png   | Bin
 .../images/button-background-disabled.png     | Bin
 .../images/button-background-disabled@2x.png  | Bin
 .../dark/images/button-background-hovered.png | Bin
 .../images/button-background-hovered@2x.png   | Bin
 .../dark/images/button-background-pressed.png | Bin
 .../images/button-background-pressed@2x.png   | Bin
 .../dark/images/button-background.png         | Bin
 .../dark/images/button-background@2x.png      | Bin
 ...flatbutton-background-checked-disabled.png | Bin
 ...tbutton-background-checked-disabled@2x.png | Bin
 .../flatbutton-background-checked-hovered.png | Bin
 ...atbutton-background-checked-hovered@2x.png | Bin
 .../flatbutton-background-checked-pressed.png | Bin
 ...atbutton-background-checked-pressed@2x.png | Bin
 .../images/flatbutton-background-checked.png  | Bin
 .../flatbutton-background-checked@2x.png      | Bin
 .../images/flatbutton-background-disabled.png | Bin
 .../flatbutton-background-disabled@2x.png     | Bin
 .../images/flatbutton-background-hovered.png  | Bin
 .../flatbutton-background-hovered@2x.png      | Bin
 .../images/flatbutton-background-pressed.png  | Bin
 .../flatbutton-background-pressed@2x.png      | Bin
 .../dark/images/flatbutton-background.png     | Bin
 .../dark/images/flatbutton-background@2x.png  | Bin
 ...oundbutton-background-checked-disabled.png | Bin
 ...dbutton-background-checked-disabled@2x.png | Bin
 ...roundbutton-background-checked-hovered.png | Bin
 ...ndbutton-background-checked-hovered@2x.png | Bin
 ...roundbutton-background-checked-pressed.png | Bin
 ...ndbutton-background-checked-pressed@2x.png | Bin
 .../images/roundbutton-background-checked.png | Bin
 .../roundbutton-background-checked@2x.png     | Bin
 .../roundbutton-background-disabled.png       | Bin
 .../roundbutton-background-disabled@2x.png    | Bin
 .../images/roundbutton-background-hovered.png | Bin
 .../roundbutton-background-hovered@2x.png     | Bin
 .../images/roundbutton-background-pressed.png | Bin
 .../roundbutton-background-pressed@2x.png     | Bin
 .../dark/images/roundbutton-background.png    | Bin
 .../dark/images/roundbutton-background@2x.png | Bin
 .../button-background-checked-disabled.png    | Bin
 .../button-background-checked-disabled@2x.png | Bin
 .../button-background-checked-hovered.png     | Bin
 .../button-background-checked-hovered@2x.png  | Bin
 .../button-background-checked-pressed.png     | Bin
 .../button-background-checked-pressed@2x.png  | Bin
 .../images/button-background-checked.png      | Bin
 .../images/button-background-checked@2x.png   | Bin
 .../images/button-background-disabled.png     | Bin
 .../images/button-background-disabled@2x.png  | Bin
 .../images/button-background-hovered.png      | Bin
 .../images/button-background-hovered@2x.png   | Bin
 .../images/button-background-pressed.png      | Bin
 .../images/button-background-pressed@2x.png   | Bin
 .../light/images/button-background.png        | Bin
 .../light/images/button-background@2x.png     | Bin
 ...flatbutton-background-checked-disabled.png | Bin
 ...tbutton-background-checked-disabled@2x.png | Bin
 .../flatbutton-background-checked-hovered.png | Bin
 ...atbutton-background-checked-hovered@2x.png | Bin
 .../flatbutton-background-checked-pressed.png | Bin
 ...atbutton-background-checked-pressed@2x.png | Bin
 .../images/flatbutton-background-checked.png  | Bin
 .../flatbutton-background-checked@2x.png      | Bin
 .../images/flatbutton-background-disabled.png | Bin
 .../flatbutton-background-disabled@2x.png     | Bin
 .../images/flatbutton-background-hovered.png  | Bin
 .../flatbutton-background-hovered@2x.png      | Bin
 .../images/flatbutton-background-pressed.png  | Bin
 .../flatbutton-background-pressed@2x.png      | Bin
 .../light/images/flatbutton-background.png    | Bin
 .../light/images/flatbutton-background@2x.png | Bin
 ...oundbutton-background-checked-disabled.png | Bin
 ...dbutton-background-checked-disabled@2x.png | Bin
 ...roundbutton-background-checked-hovered.png | Bin
 ...ndbutton-background-checked-hovered@2x.png | Bin
 ...roundbutton-background-checked-pressed.png | Bin
 ...ndbutton-background-checked-pressed@2x.png | Bin
 .../images/roundbutton-background-checked.png | Bin
 .../roundbutton-background-checked@2x.png     | Bin
 .../roundbutton-background-disabled.png       | Bin
 .../roundbutton-background-disabled@2x.png    | Bin
 .../images/roundbutton-background-hovered.png | Bin
 .../roundbutton-background-hovered@2x.png     | Bin
 .../images/roundbutton-background-pressed.png | Bin
 .../roundbutton-background-pressed@2x.png     | Bin
 .../light/images/roundbutton-background.png   | Bin
 .../images/roundbutton-background@2x.png      | Bin
 examples/demos/lightningviewer/main.cpp       |  19 +--
 .../resources/lv_style/lv_style.qrc           | 105 --------------
 .../lightningviewer/resources/lv_style/qmldir |   5 -
 .../lightningviewer/resources/qml/qmldir      |  10 --
 .../lightningviewer/resources/resources.qrc   |  23 ---
 135 files changed, 252 insertions(+), 211 deletions(-)
 rename examples/demos/lightningviewer/{resources/qml => }/ActionsLayer.qml (99%)
 rename examples/demos/lightningviewer/{resources/qml => }/DistanceTimeLayer.qml (99%)
 rename examples/demos/lightningviewer/{resources/qml => }/LightningMapLayer.qml (98%)
 rename examples/demos/lightningviewer/{resources/qml => }/LightningView.qml (79%)
 rename examples/demos/lightningviewer/{resources/qml => }/LightningViewConfig.qml (100%)
 create mode 100644 examples/demos/lightningviewer/Main.qml
 rename examples/demos/lightningviewer/{resources/qml => }/MapLayersDrawer.qml (99%)
 rename examples/demos/lightningviewer/{resources/qml => }/MapLayersItem.qml (99%)
 rename examples/demos/lightningviewer/{resources/qml => }/MapType.qml (100%)
 rename examples/demos/lightningviewer/{resources/qml => }/MapView.qml (100%)
 rename examples/demos/lightningviewer/{resources/qml => }/SwitchMap.qml (99%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/distance.svg (100%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/globe.svg (100%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/lightning-layer.svg (100%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/lightning-strike.svg (100%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/map-layers.svg (100%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/map.svg (100%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/recenter.svg (100%)
 rename examples/demos/lightningviewer/{resources/assets => }/icons/user-location.svg (100%)
 rename examples/demos/lightningviewer/{data => }/laststrikeinfo.h (100%)
 rename examples/demos/lightningviewer/{data => }/lightningitemdata.cpp (100%)
 rename examples/demos/lightningviewer/{data => }/lightningitemdata.h (97%)
 rename examples/demos/lightningviewer/{models => }/lightningitemmodel.cpp (98%)
 rename examples/demos/lightningviewer/{models => }/lightningitemmodel.h (96%)
 rename examples/demos/lightningviewer/{providers => }/lightningprovider.cpp (100%)
 rename examples/demos/lightningviewer/{providers => }/lightningprovider.h (95%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/Button.qml (100%)
 create mode 100644 examples/demos/lightningviewer/lv_style/CMakeLists.txt
 rename examples/demos/lightningviewer/{resources => }/lv_style/Config.qml (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/RoundButton.qml (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/StyleImage.qml (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-checked@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/button-background@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-checked@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/flatbutton-background@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-checked@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/dark/images/roundbutton-background@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-checked@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/button-background@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-checked@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/flatbutton-background@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-checked@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-disabled.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-disabled@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-hovered.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-hovered@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-pressed.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background-pressed@2x.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background.png (100%)
 rename examples/demos/lightningviewer/{resources => }/lv_style/light/images/roundbutton-background@2x.png (100%)
 delete mode 100644 examples/demos/lightningviewer/resources/lv_style/lv_style.qrc
 delete mode 100644 examples/demos/lightningviewer/resources/lv_style/qmldir
 delete mode 100644 examples/demos/lightningviewer/resources/qml/qmldir
 delete mode 100644 examples/demos/lightningviewer/resources/resources.qrc

diff --git a/examples/demos/lightningviewer/resources/qml/ActionsLayer.qml b/examples/demos/lightningviewer/ActionsLayer.qml
similarity index 99%
rename from examples/demos/lightningviewer/resources/qml/ActionsLayer.qml
rename to examples/demos/lightningviewer/ActionsLayer.qml
index db78faf5..2619055c 100644
--- a/examples/demos/lightningviewer/resources/qml/ActionsLayer.qml
+++ b/examples/demos/lightningviewer/ActionsLayer.qml
@@ -5,8 +5,7 @@ import QtQuick
 import QtLocation
 import QtQuick.Layouts
 import QtQuick.Controls
-
-import lv_style 1.0
+import lv_style
 
 Item {
     id: actionsLayer
diff --git a/examples/demos/lightningviewer/CMakeLists.txt b/examples/demos/lightningviewer/CMakeLists.txt
index c4db201a..7fb8ef1c 100644
--- a/examples/demos/lightningviewer/CMakeLists.txt
+++ b/examples/demos/lightningviewer/CMakeLists.txt
@@ -2,50 +2,87 @@
 # SPDX-License-Identifier: BSD-3-Clause
 
 cmake_minimum_required(VERSION 3.16)
+project(LightningViewer VERSION 1.0 LANGUAGES CXX)
 
-set(APP_NAME LightningViewerExample)
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+set(CMAKE_AUTOMOC ON)
 
-project(LightningViewerExample VERSION 0.1 LANGUAGES CXX)
+if(NOT DEFINED INSTALL_EXAMPLESDIR)
+    set(INSTALL_EXAMPLESDIR "examples")
+endif()
 
-set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/demos/lightningviewer")
 
-find_package(Qt6 6.5 REQUIRED COMPONENTS Quick WebSockets Positioning)
+find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick QuickControls2 WebSockets Positioning)
 
 qt_standard_project_setup(REQUIRES 6.5)
 
-set(CMAKE_AUTORCC ON)
-qt_add_executable(${APP_NAME}
+add_subdirectory(lv_style)
+
+qt_add_executable(lightningviewerexample WIN32
     main.cpp
-    controller.h controller.cpp
-    data/laststrikeinfo.h
-    data/lightningitemdata.h data/lightningitemdata.cpp
-    models/lightningitemmodel.h models/lightningitemmodel.cpp
-    providers/lightningprovider.h providers/lightningprovider.cpp
-    resources/resources.qrc
-    resources/lv_style/lv_style.qrc
 )
 
-target_link_libraries(${APP_NAME} PRIVATE
+set_source_files_properties(LightningViewConfig.qml MapType.qml
+    PROPERTIES
+        QT_QML_SINGLETON_TYPE TRUE
+)
+
+qt_add_qml_module(lightningviewerexample
+   URI lightningviewer
+   QML_FILES
+       Main.qml
+       ActionsLayer.qml
+       DistanceTimeLayer.qml
+       LightningMapLayer.qml
+       LightningView.qml
+       LightningViewConfig.qml
+       MapLayersDrawer.qml
+       MapLayersItem.qml
+       MapType.qml
+       MapView.qml
+       SwitchMap.qml
+   SOURCES
+       controller.h controller.cpp
+       laststrikeinfo.h
+       lightningitemdata.h lightningitemdata.cpp
+       lightningitemmodel.h lightningitemmodel.cpp
+       lightningprovider.h lightningprovider.cpp
+   RESOURCES
+       icons/distance.svg
+       icons/globe.svg
+       icons/lightning-layer.svg
+       icons/lightning-strike.svg
+       icons/map-layers.svg
+       icons/map.svg
+       icons/recenter.svg
+       icons/user-location.svg
+)
+
+target_link_libraries(lightningviewerexample PRIVATE
+    Qt6::Core
+    Qt6::Gui
     Qt6::Quick
     Qt6::WebSockets
     Qt6::Positioning
 )
 
-# Qt for iOS sets MACOSX_BUNDLE_GUI_IDENTIFIER automatically since Qt 6.1.
-# If you are developing for iOS or macOS you should consider setting an
-# explicit, fixed bundle identifier manually though.
-set_target_properties(${APP_NAME} PROPERTIES
-#    MACOSX_BUNDLE_GUI_IDENTIFIER com.example.appLightningViewer
-    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
-    MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/Info.plist"
-    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
-    MACOSX_BUNDLE TRUE
-    WIN32_EXECUTABLE TRUE
-)
+add_dependencies(lightningviewerexample lightningviewer_style)
 
-include(GNUInstallDirs)
-install(TARGETS ${APP_NAME}
-    BUNDLE DESTINATION .
-    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+install(TARGETS lightningviewerexample
+    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
+    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
+    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
 )
+
+
+#Qt for iOS sets MACOSX_BUNDLE_GUI_IDENTIFIER automatically since Qt 6.1.
+#If you are developing for iOS or macOS you should consider setting an
+#explicit, fixed bundle identifier manually though.
+# set_target_properties(lightningviewerexample PROPERTIES
+#    MACOSX_BUNDLE_GUI_IDENTIFIER com.example.appLightningViewer
+#    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
+#    MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/Info.plist"
+#    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
+#    MACOSX_BUNDLE TRUE
+# )
diff --git a/examples/demos/lightningviewer/resources/qml/DistanceTimeLayer.qml b/examples/demos/lightningviewer/DistanceTimeLayer.qml
similarity index 99%
rename from examples/demos/lightningviewer/resources/qml/DistanceTimeLayer.qml
rename to examples/demos/lightningviewer/DistanceTimeLayer.qml
index 5896b3c9..355f0234 100644
--- a/examples/demos/lightningviewer/resources/qml/DistanceTimeLayer.qml
+++ b/examples/demos/lightningviewer/DistanceTimeLayer.qml
@@ -3,6 +3,7 @@
 
 import QtQuick
 import QtQuick.Layouts
+import lightningviewer
 
 Item {
     id: distanceTimeLayer
diff --git a/examples/demos/lightningviewer/resources/qml/LightningMapLayer.qml b/examples/demos/lightningviewer/LightningMapLayer.qml
similarity index 98%
rename from examples/demos/lightningviewer/resources/qml/LightningMapLayer.qml
rename to examples/demos/lightningviewer/LightningMapLayer.qml
index 056a7762..7cede463 100644
--- a/examples/demos/lightningviewer/resources/qml/LightningMapLayer.qml
+++ b/examples/demos/lightningviewer/LightningMapLayer.qml
@@ -4,6 +4,7 @@
 import QtQuick
 import QtLocation
 import QtPositioning
+import lightningviewer
 
 MapItemView {
     id: lightningMapLayer
diff --git a/examples/demos/lightningviewer/resources/qml/LightningView.qml b/examples/demos/lightningviewer/LightningView.qml
similarity index 79%
rename from examples/demos/lightningviewer/resources/qml/LightningView.qml
rename to examples/demos/lightningviewer/LightningView.qml
index 26b00fa9..d4ce2c4d 100644
--- a/examples/demos/lightningviewer/resources/qml/LightningView.qml
+++ b/examples/demos/lightningviewer/LightningView.qml
@@ -3,8 +3,9 @@
 
 import QtQuick
 import QtQuick.Controls
+import lightningviewer
 
-ApplicationWindow {
+Item {
     visible: true
 
     MapView {
@@ -30,11 +31,4 @@ ApplicationWindow {
         property: "distanceTimeLayerEnabled"
         value: actionsLayer.distanceLayerVisible
     }
-
-    Component.onCompleted: {
-        if ((width < 200) || (height < 200)) {
-            width = LightningViewConfig.appWidth
-            height = LightningViewConfig.appHeight
-        }
-    }
 }
diff --git a/examples/demos/lightningviewer/Main.qml b/examples/demos/lightningviewer/Main.qml
new file mode 100644
index 00000000..1c9446e4
--- /dev/null
+++ b/examples/demos/lightningviewer/Main.qml
@@ -0,0 +1,22 @@
+// Copyright (C) 2024 The Qt Company Ltd.
+// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
+
+import QtQuick
+import QtQuick.Controls
+import lightningviewer
+
+ApplicationWindow {
+    visible: true
+
+    LightningView {
+        anchors.fill: parent
+    }
+
+
+    Component.onCompleted: {
+        if ((width < 200) || (height < 200)) {
+            width = LightningViewConfig.appWidth
+            height = LightningViewConfig.appHeight
+        }
+    }
+}
diff --git a/examples/demos/lightningviewer/resources/qml/MapLayersDrawer.qml b/examples/demos/lightningviewer/MapLayersDrawer.qml
similarity index 99%
rename from examples/demos/lightningviewer/resources/qml/MapLayersDrawer.qml
rename to examples/demos/lightningviewer/MapLayersDrawer.qml
index 2427c592..75e3d6a4 100644
--- a/examples/demos/lightningviewer/resources/qml/MapLayersDrawer.qml
+++ b/examples/demos/lightningviewer/MapLayersDrawer.qml
@@ -5,7 +5,7 @@ import QtQuick
 import QtQuick.Layouts
 import Qt5Compat.GraphicalEffects
 
-import lv_style 1.0
+import lv_style
 
 Item {
     id: drawer
diff --git a/examples/demos/lightningviewer/resources/qml/MapLayersItem.qml b/examples/demos/lightningviewer/MapLayersItem.qml
similarity index 99%
rename from examples/demos/lightningviewer/resources/qml/MapLayersItem.qml
rename to examples/demos/lightningviewer/MapLayersItem.qml
index 6195ec21..0e2bbce8 100644
--- a/examples/demos/lightningviewer/resources/qml/MapLayersItem.qml
+++ b/examples/demos/lightningviewer/MapLayersItem.qml
@@ -3,8 +3,7 @@
 
 import QtQuick
 import QtQuick.Layouts
-
-import lv_style 1.0
+import lv_style
 
 Item {
     id: mapLayersItem
diff --git a/examples/demos/lightningviewer/resources/qml/SwitchMap.qml b/examples/demos/lightningviewer/SwitchMap.qml
similarity index 99%
rename from examples/demos/lightningviewer/resources/qml/SwitchMap.qml
rename to examples/demos/lightningviewer/SwitchMap.qml
index 6d2acddb..4aee4afc 100644
--- a/examples/demos/lightningviewer/resources/qml/SwitchMap.qml
+++ b/examples/demos/lightningviewer/SwitchMap.qml
@@ -3,8 +3,7 @@
 
 import QtQuick
 import QtQuick.Layouts
-
-import lv_style 1.0
+import lv_style
 
 Item {
     id: switchMap
